/* MAINTAINER: Bernard */

#include "font.h"
#include "application_client.h"
#include "game_client.h"
#include "camera.h"

Font::Font()
{
	
}

Font::~Font()
{
	
}

void Font::cleanCache()
{

}

void Font::RenderUTF8(const std::string &utf8str, int x, int y, Position pos)
{
	switch(pos)
	{
	case LEFT_BOTTOM: 
		RenderUTF8(utf8str, x, y);
		break;
	case CENTER_CENTER:
	case CENTER:
		RenderUTF8(utf8str, x-getTextWidth(utf8str)/2,  y-Ascent()/2);
		break;
	case CENTER_BOTTOM:
		RenderUTF8(utf8str, x-getTextWidth(utf8str)/2, y);
	case RIGHT_BOTTOM:
		RenderUTF8(utf8str, x-getTextWidth(utf8str), y);	
		break;
	}
}

void Font::RenderUTF83D(const std::string &utf8str, float x, float y, float z, float scale)
{
	
	Camera* c =  getAppClient().getGame().getCamera();
	if (c == 0)
	{
		RenderUTF83D(utf8str, x, y, z, scale, 1, 0, true, true);
		return;
	}
	
	GLVector3d cam;
	c->getPos(cam);

	GLVector2f dir(x-(float)cam.x, y-(float)cam.y);

	if (dir.lengthSqr() == 0) return;
	dir.normalize();

	RenderUTF83D(utf8str, x, y, z, scale, -dir.y, dir.x, true, true);
}

void Font::RenderUTF8WithShadow(const std::string &utf8str, int x, int y,
					        float r, float g, float b, Font::Position pos)
{
	glColor3f( 0.0, 0.0, 0.0);
	RenderUTF8(utf8str, x+1, y-1, pos);
	
	glColor3f( r, g, b);
	RenderUTF8(utf8str, x, y, pos);				        	
}					        	
