/* MAINTAINER: Bernard */

#include "font.h"
#include "font_ttf.h"
#include "font_manager.h"
#include "platform.h"
#include "log.h"
#include "conversions.h"

// This is temorary here not to forget about FTGLTextureFont	
/*
	getAppClient().getGFX().set3DOpenGL();
	glDisable( GL_DEPTH_TEST);
	glEnable( GL_TEXTURE_2D);
	FTGLTextureFont fonttex(locateFile("FreeMono.ttf").c_str());
	fonttex.FaceSize(20);
	glLoadIdentity();
	glNormal3f( 0.0, 0.0, 1.0);
	glTranslatef( -1.5f, 0.0f, -90.0f );
	glColor3f( 1.0, 1.0, 0.0);
	glPushMatrix();
	fonttex.Render("Hello - texture");
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
*/

using namespace std;

FontManager::FontManager()
{
	mNextCleanup = 2000;
}

FontManager::~FontManager()
{

}

FontManager::TUniversalManager::TRef FontManager::get(const char* font_name, int size)
{
	string key = font_name;
	key.append(":").append(xtos(size));
	
	// I. FIND
	ManagedItem * pmi;
	if ((pmi = find(key)) != 0)
		return pmi;

    // II. INIT
	Font* font = new FontTTF(locateFile(font_name).c_str(), size);
//	Font* font = new FontFTGL(locateFile(font_name).c_str(), size);
	if (!font)
	{
		LOGE << "Loading font failed!" << endl;
		DIE();
	}

	// III. REGISTER
	return createAndRegister(key, font);
}

void FontManager::update(int dtime, int atime)
{
	mNextCleanup -= dtime;
	if (mNextCleanup <= 0)
	{
		LOGT << "Cleaning font chache" << endl;
		mNextCleanup = 2000;	
		// call 
		for (TContainer::iterator it = mRegister.begin(), ite = mRegister.end(); it != ite; ++it)
		{
			ManagedItem * pmi = it->second;
			pmi->getPtr()->cleanCache();
			
		}
	}
}
