/* MAINTAINER: Bernard */
#ifndef _FONT_TEXTURE_H
#define _FONT_TEXTURE_H

#include "texturemanager.h"


/**
 * \brief Special texture class for holding TTF text.
 * 
 * Special case is that the texture may be created from surface
 * and correct parameters are passed. These textures are not ment
 * to be managed by texture manager.
 */
class FontTexture: public Texture
{
public:
	/**
	 * \brief Create the texture by uploading surface with rendered text.
	 * 
	 * \param psf Surface with text.
	 */
	void create( SurfaceFactory * psf )                                  
	{                                                                    
  		// Create an OpenGL texture, internal format RGB + A and no mipmaps
		this->upload( psf, GL_RGBA, 0 );
	}                                                                    
};                                                                   
                                                                     
// create moson:                                                     
//MyOwnSpecializedSuperOneTexture moson;                               
//SDL_Surface * source;                                                
//SurfDefault sd( source );                                            
//moson.create( &sd )                                                  
                                                                     
// use moson:                                                        
//moson.bind(); // bind texture                                        
//GLuint id = moson.getID(); // get ID                                 
// ..etc                                                             

#endif
