/* MAINATINER: Martin */

#include "terrain_simple.h"

TerrainSimple::~TerrainSimple(void)
{}

void TerrainSimple::render(void)
{	
	const int step = 1;

	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);

	int sizeX, sizeY;
	getExtents(sizeX, sizeY);
	// TODO: preserving/restoring modelview matrix should be avoided!

	// Preserve modelview matrix.
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	
	// Set scale.
	getRealScale().glScale();
	
	// s, t vectors for generating global texture coordinates
	GLVector4f tv[2] = {
		GLVector4f(1.0f/sizeX, 0.0f, 0.f, 0.0f),
		GLVector4f(0.0f, 1.0f/sizeY, 0.f, 0.0f)
	};

	// generate texture coordinates
	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	glTexGenfv(GL_S, GL_OBJECT_PLANE, tv[0].val);
	glTexGenfv(GL_T, GL_OBJECT_PLANE, tv[1].val);
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);

	mGlobalTexture->bind();
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	glColor3f(1.0, 1.0, 1.0);
	for (int x, y = 0; y < sizeY-step; y+=step)
		for (x = 0; x < sizeX-step; x+=step)
		{
			glBegin(GL_QUADS);
				glVertex3i(x, y, getTrueHeight(x, y));
				glVertex3i(x+step, y, getTrueHeight(x+step, y));
				glVertex3i(x+step, y+step, getTrueHeight(x+step, y+step));
				glVertex3i(x, y+step, getTrueHeight(x, y+step));
			glEnd();
		}

	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);

	glLoadIdentity();

	glDisable(GL_TEXTURE_2D);

	// Restore modelview matrix.
	glPopMatrix();
}

