/* MAINTAINER: Martin */

#ifndef _TERRAIN_SIMPLE_H
#define _TERRAIN_SIMPLE_H

#include "visual_terrain.h"

/** \addtogroup game_data */ /*@{ */

/**
*	\brief Simple terrain implementation. Level Of Detail - None.
*
*	Brute force algorithm, renders "all", triangle count is reduced by some constant that 
*	defines the field size (i.e. 1 is for full-detail 1x1, 10 for 10x10 squares).
*
*	\note This is the specific terrain implementation (where some LOD could be implemented).
*		Implements VisualTerrain::render() and possibly VisualTerrain::update() methods.
*/
class TerrainSimple: public VisualTerrain
{
public:
	~TerrainSimple();
	void render();
};

/*@}*/

#endif //_TERRAIN_SIMPLE_H

