#ifndef _GUI_CONSTANTS_H
#define _GUI_CONSTANTS_H

#include <string>

class GUIConstants
{
public:
	GUIConstants();

	void load(); // probably from some file

/* *********** INFOLAYER ************ */
	std::string info_font;
	int         info_font_size;
	std::string info_icons_font;
	int         info_icons_font_size;
	
	/* text with readyness info */
	float info_str_r;
	float info_str_g;
	float info_str_b;
	float info_str_key_r;
	float info_str_key_g;
	float info_str_key_b;
	int	  info_str_pos_percentage;
	
	int   bonus_wx;
	int   bonus_y;
	int   bonus_dy;


	std::string kills_icon;
	int   kills_wx; // position w-x
	int   kills_y;   // icon y
	int   kills_ty;  // text y
	float kills_r;
	float kills_g;
	float kills_b;
	
	int   weapon_wx; 
	int   weapon_y;
	int   weapon_ty;
	float weapon_r;
	float weapon_g;
	float weapon_b;
	float weapon_r_critical;
	float weapon_g_critical;
	float weapon_b_critical;
	float weapon_critical_ammo;

	std::string lives_icon;
	int   lives_wx; 
	int   lives_y;
	int   lives_ty;
	float lives_r_ok;
	float lives_g_ok;
	float lives_b_ok;
	float lives_r_ko;
	float lives_g_ko;
	float lives_b_ko;

	std::string armour_icon;
	int   armour_wx;
	int   armour_y;
	int   armour_ty;
	float armour_min_r;
	float armour_min_g;
	float armour_min_b;
	float armour_max_r;
	float armour_max_g;
	float armour_max_b;

	
	std::string radar_icon;
	int radar_x;
	int radar_y;
	int radar_icon_radius;
	double radar_radius;
	float  radar_point_size;
	double radar_tank_r;
	double radar_tank_g;
	double radar_tank_b;
	double radar_bonus_r;
	double radar_bonus_g;
	double radar_bonus_b;
	double radar_projectile_r;
	double radar_projectile_g;
	double radar_projectile_b;
	double radar_other_r;
	double radar_other_g;
	double radar_other_b;

	float  aim_point_size;
	double aim_r;
	double aim_g;
	double aim_b;
	double aim_dtime;
	double aim_max_time;
	double aim_stime;
	std::string aim_gunsight_icon;
	std::string aim_gunsight_icon_out;
	std::string aim_gunsight_icon_small;

	int pause_msg_dy;
	
	std::string messages_font;
	int   messages_font_size;
	int   messages_lines;
	int   messages_top;
	int   messages_left;
	int   messages_max_time;
	int   messages_fade_time;
	float messages_r;
	float messages_g;
	float messages_b;
	float messages_edit_r;
	float messages_edit_g;
	float messages_edit_b;

	float tank_names_font_scale;
	float tank_names_z;

	int   blood_maxhit;
	int   blood_delay;
	int   blood_minhit;
	std::string blood_bighit_sound;
	std::string blood_smallhit_sound;


/* *********** statswindow ************ */
	
	std::string stats_header_font;
	std::string stats_data_font;
	std::string stats_win_image;
	std::string stats_ready_image;
    int			stats_ready_image_size;
	int			stats_header_font_size;
	int			stats_data_font_size;
	float		stats_header_font_r;
	float		stats_header_font_g;
	float		stats_header_font_b;
	float		stats_data_font_r;
	float		stats_data_font_g;
	float		stats_data_font_b;
	float		stats_self_font_r;
	float		stats_self_font_g;
	float		stats_self_font_b;
	float		stats_odd_line_box_r;
	float		stats_odd_line_box_g;
	float		stats_odd_line_box_b;
	float		stats_odd_line_box_a;
	float		stats_even_line_box_r;
	float		stats_even_line_box_g;
	float		stats_even_line_box_b;
	float		stats_even_line_box_a;
	int			stats_win_vertical_percentage;
	int			stats_win_horizontal_percentage;
	int			stats_win_header_divider_percentage;
	int			stats_win_line_indent_percentage;
	int			stats_win_name_col_percentage;
	int			stats_win_score_col_percentage;
	int			stats_win_kills_col_percentage;
	int			stats_win_deaths_col_percentage;
	int			stats_line_separation_width;
	int			stats_line_width;

/* *********** Console ************ */

	int   fps_wx;
	int   fps_hy;
	float fps_r;
	float fps_g;
	float fps_b;

	int   con_box_x;
	int   con_box_dy;
	float con_box_r;
	float con_box_g;
	float con_box_b;
	float con_box_a;

	std::string con_font;
	int con_font_size;
	int con_font_x;
	int con_font_hy;

	std::string con_errmsg_font;
	int   con_errmsg_font_size;	
	float con_errmsg_r;
	float con_errmsg_g;
	float con_errmsg_b;
	int   con_errmsg_max_time;
	int   con_errmsg_fade_time;
	
	

/* ************* Loading window *******/
	std::string loading_font;
	int         loading_font_size;

/* ************ Ingame menu *********/
    int         ingame_autoshow_delay;

/* *********** Main menu **********/
    std::string mmain_background;

	struct sConditions
	{
		std::string	position;
		std::string	namefont;
		std::string	valuefont;
		int			namesize;
		int			valuesize;
		float		name_r;
		float		name_g;
		float		name_b;
		float		value_r;
		float		value_g;
		float		value_b;
		int			width;
		int			border_space;
	};
	sConditions conditions;
};

extern GUIConstants gc;

#endif
