#ifndef  _STATS_WINDOW_H
#define  _STATS_WINDOW_H

#include "font_manager.h"
#include "texturemanager.h"
#include "opengl2d.h"

class Player;

class StatsWindow
{
public:
	StatsWindow();
	virtual ~StatsWindow();
	
	void setPlayer(Player *player) { mPlayer = player; }

	virtual void init();

	virtual void clean();

	virtual void render();

	void show(bool visible) { mVisible = visible; }
	bool isVisible() { return mVisible; }

private:	
	
	void textWithShadow( const FontRef & font, const std::string &text, int win_height, int x, int y, float color[4] );

	Player	*mPlayer;		///< Monitored player. May be NULL.
	bool	mVisible;

	TextureRef mTexture;	///< Texture with picture of stats window
	Texture2DGL mTickImage;	///< Texture with image of tick (indicating player is ready)

	FontRef	mHeaderFont;	///< Font for rendering header in table with stats
	FontRef	mDataFont;		///< font for data lines in table with stats
};

#endif // _STATS_WINDOW_H
