/* MAINTAINER: Bernard */

#include "application_client.h"
#include "game_state_copy.h"
#include "game_client.h"
#include "tank.h"
#include "player.h"


GameStateCopyClient::GameStateCopyClient()
{
	mYaw   = 0;
	mPitch = 0;
	mFire  = false;
}

GameStateCopyClient::~GameStateCopyClient()
{

}

void GameStateCopyClient::updateCopy()
{	
	// Copy YAW and PITCH from current's player tank.
	Player *player = getAppClient().getGame().getClientPlayer();
	if (player)
	{	
		Tank *tank = player->getTank();
		if (tank)
		{
			mMutex.lock();
				mYaw   = tank->getYaw();
				mPitch = tank->getPitch();
			mMutex.unlock();
		}
	}
}

void GameStateCopyClient::getYawPitch(double &yaw, double &pitch)
{
	mMutex.lock();
		yaw   = mYaw;
		pitch = mPitch;
	mMutex.unlock();	
}

void GameStateCopyClient::setFire(bool fire)
{
	mMutex.lock();
		mFire = fire;
	mMutex.unlock();
}

bool GameStateCopyClient::getFire()
{
	mMutex.lock();
		bool rv = mFire;
	mMutex.unlock();
	
	return rv;
}
