/* MAINTAINER: Martin */
#ifndef _GOBJ_RENDER_VISITOR_H
#define _GOBJ_RENDER_VISITOR_H

#include "gobj_visitor.h"

#include "stlextdefs.h"
#include "hash_hack.h"

namespace hna
{
class Material;
}

namespace gobj
{
	class RenderVisitor: public Visitor
	{
	public:
		RenderVisitor();
		virtual ~RenderVisitor();

		virtual void visitBox(const class Box * box);
		virtual void visitSphere(const class Sphere * sphere);
		virtual void visitTriMesh(const class TriMesh * trimesh);

		/** \brief display list to GeometryObjects binding */
		//typedef STL_EXT_NS::hash_map< const class GeometryObject *, int> TGobjDisplayLists;

		/**
		*	\brief creates display list for geometry object if it doesn't exist yet
		*	\return true to continue
		*	\note do not forget to call endDL() at the end of DL block!
		*/
		//bool beginDL( const class GeometryObject * go );

		/**
		*	\brief finishes display list creating if DL was previously created
		*/
		//void endDL();

		void setMaterial( hna::Material * mat );

	private:
		hna::Material * getMaterial();
		
		//static TGobjDisplayLists mDLs;
		//bool mDLCreated, mUseDL;
		//unsigned int mDL;
		hna::Material * mMaterial;

	};
}

#endif //_GOBJ_RENDER_VISITOR_H

