#include "animation.h"

AnimationController::~AnimationController()
{
}

Animation::~Animation()
{
	enable(false);

	controller_container_type::iterator it, ite;
	getAllControllers(it, ite);
	for (; it != ite; ++it )
	{
		delete (*it);
		(*it) = 0;
	}
}

void Animation::update( class Model * model, unsigned int time_ms )
{
	controller_container_type::iterator it, ite;
	getAllControllers(it, ite);
	for (; it != ite; ++it )
	{
		AnimationController * p = *it;

		p->update( model, time_ms );
	}
}

void Animation::createController( std::auto_ptr< AnimationController > animController )
{
	// TODO: speedup & style: take ownership of animController and store it in animation internals (2DO: better way)
	mControllerList.push_front( animController.release() );
}
