/* MAINTAINER: Martin */
#ifndef _GRAPHICAL_REPRESENTATION_CREATOR_H_
#define _GRAPHICAL_REPRESENTATION_CREATOR_H_

#include "hierarchynodevisitor.h"
#include "hna_visitor.h"

namespace hna
{
	class Material;
};

class MaterialObtainer: public hna::AttrVisitor
{
public:
	MaterialObtainer()
		: mMaterial(0)
	{}

	virtual void visitMaterial( hna::Material * m )
	{
		mMaterial = m;
	}

	hna::Material * getMaterial()
	{
		return mMaterial;
	}

	void clearState()
	{
		mMaterial = 0;
	}

private:
	hna::Material * mMaterial;
};


class GraRepCreator: protected HierarchyNodeVisitor
{
public:
	
	bool createGraphicalRepresentation( class Model * model );
	
protected:

	virtual void visitHierarchyNode(class HierarchyNode * node);
};


#endif // _GRAPHICAL_REPRESENTATION_CREATOR_H_
