#include "hn_attributeapplyvisitor.h"
#include "hna_transform.h"
#include "hna_material.h"

void AttributeApplyVisitor::visitTransformation(hna::Transformation *arg)
{
	setVisitedTransformation( arg );

	switch ( getState() )
	{
	
	case applyEffect:
		arg->applyEffect();
		break;

	case removeNodeEffect:
		arg->removeTemporaryEffect();
		break;

	case removeSubtreeEffect:
		arg->removeHierarchyEffect();
		break;

	default:
		return;
	}
}

void AttributeApplyVisitor::visitMaterial(hna::Material *arg)
{
	// tenhle jsme navstivili uz minule...
	if ( arg == getVisitedMaterial() )
		return;

	setVisitedMaterial( arg );

	switch ( getState() )
	{
	
	case applyEffect:
		// setup of texturing environment, binding of mapping channels to texture units
		arg->applyEffect();
		break;

	case removeNodeEffect:
		// TODO: remove material effect
		arg->removeEffect();
		break;

	case removeSubtreeEffect:
		// TODO: remove material effect
		break;

	default:
		return;
	}
}
