#ifndef _HN_ATTRIBUTE_APPLY_VISITOR_H_
#define _HN_ATTRIBUTE_APPLY_VISITOR_H_

#include "hna_visitor.h"

class AttributeApplyVisitor: public hna::AttrVisitor
{
public:
	enum State {
		applyEffect,
		removeNodeEffect,
		removeSubtreeEffect,
	};

	AttributeApplyVisitor():
	  mState(applyEffect)
	{
		clearReferencesToVisitedObjects();
	}
	
	void setState(State s) { mState = s; }
	State getState() { return mState; }
	
	virtual void visitTransformation(hna::Transformation * arg);
	virtual void visitMaterial(hna::Material * arg);
	
	void clearReferencesToVisitedObjects()
	{
		setVisitedMaterial(0);
		setVisitedTransformation(0);
	}

	hna::Material * getVisitedMaterial() 
	{ return mVisitedMaterial; }

	hna::Transformation * getVisitedTransformation() 
	{ return mVisitedTransformation; }

private:

	void setVisitedMaterial(hna::Material * arg) { mVisitedMaterial = arg; }
	void setVisitedTransformation(hna::Transformation * arg) { mVisitedTransformation = arg; }

	State mState;
	
	// references to visited objects
	hna::Material * mVisitedMaterial;
	hna::Transformation * mVisitedTransformation;
};

#endif

