#include "model.h"
#include "animation.h"
#include <memory>

Animation * Model::createAnimation( const std::string & animationName )
{	
	std::auto_ptr<Animation> tmp(new Animation());
	// TODO: feature: use animationName to identify the animation
	
	Animation * a(0);
	
	this->mAnimationList.push_front( a = tmp.release() );
	return a;
}

void Model::clearAnimation()
{
	anim_container_type::iterator it, ite;
	getAllAnimation( it, ite );
	for (; it != ite; ++it )
	{
		delete *it;
		*it = 0;
	}
	mAnimationList.clear();
}

void Model::updateAnimation( unsigned int time_ms )
{
	anim_container_type::iterator it, ite;
	getAllAnimation( it, ite );
	for (; it != ite; ++it )
		(*it)->update( this, time_ms );
}
