/* MAINTAINER: Lukas */

#include "asyncconnect.h"
#include "corbaexceptionmacros.h"
#include "application_client.h"
#include "networkmanager_client.h"

AsyncConnect::resultCPtr AsyncConnect::invoke(const Connector_var connector,
											  const string playerName,
											  const Client_var client)
{
	AsyncConnect::resultCPtr result = prepareResult();

	// TODO LUKAS toto do jobu
	try
	{
		if( CORBA::is_nil(connector) )
			LOGE << "Can't narrow server reference from IOR(or it was nil)." << endl;
		else
			connector->connect(playerName.c_str(), client);
	}
	catch(CORBA::SystemException& e)
	{
		SYSEXCEPTION_ERROR("Can't connect")

		// TODO LUKAS v jobu bude owner
		getAppClient().getNetworkManager().getNetworkReceiver().
			connectedCallback(Server::_nil(), INVALID_PLAYER_ID, "Corba error!");
	}
	catch(CORBA::Exception& e)
	{
		EXCEPTION_ERROR("Can't connect")

		// TODO LUKAS v jobu bude owner
		getAppClient().getNetworkManager().getNetworkReceiver().
			connectedCallback(Server::_nil(), INVALID_PLAYER_ID, "Corba error!");
	}
	catch(omniORB::fatalException& e)
	{
		OMNIORB_FATAL_EXCEPTION("Can't connect")
	}
	catch(...)
	{
		UNKNOWN_ERROR("Can't connect")
	}

	return result;
}
