/* MAINTAINER: Lukas */

#include "asyncgameinfo.h"
#include "corbaexceptionmacros.h"
#include "application_client.h"
#include "networkmanager_client.h"

AsyncGameInfo::resultCPtr AsyncGameInfo::invoke(const Server_var server)
{
	TIN

	AsyncGameInfo::resultCPtr result = prepareResult();

	if(! CORBA::is_nil(server))
	{
		bool connectionProblem = false;

		try
		{
			server->gameInfoRequest();
		}
		catch(CORBA::SystemException& e)
		{
			SYSEXCEPTION_ERROR("Can't get game info")

			connectionProblem = true;
		}
		catch(CORBA::Exception& e)
		{
			EXCEPTION_ERROR("Can't get game info")

			connectionProblem = true;
		}
		catch(omniORB::fatalException& e)
		{
			OMNIORB_FATAL_EXCEPTION("Can't get game info")
		}
		catch(...)
		{
			UNKNOWN_ERROR("Can't get game info")
		}

		if(connectionProblem)
		{
			LOGI << "Connection problem." << std::endl;

			getAppClient().getNetworkManager().disconnect();
		}
	}

	return result;
}
