/* MAINTAINER: Lukas */

#include "netobjects_client.h"
#include "application_client.h"
#include "networkmanager_client.h"
#include "game.h"

// Methods corresponding to IDL attributes and operations
void Client_i::sendGameState(const NETGameState & gameState)
{
	if(! mActive)
		return;

	getAppClient().getNetworkManager().getNetworkReceiver().addGameState(gameState);
}

void Client_i::connectCallback(Server_ptr se, CORBA::Long playerID, const char *msg)
{
	if(! mActive)
		return;

	getAppClient().getNetworkManager().getNetworkReceiver().
		connectedCallback(Server::_duplicate(se), playerID, msg);
}

void Client_i::gameInfoCallback(const NETGameInfo &gameInfo)
{
	GameInfo * gi = new GameInfo();

	// copy data
	gi->mapName = gameInfo.mapName;

	getAppClient().getNetworkManager().getNetworkReceiver().gameInfoCallback(gi);
}
