/* MAINTAINER: Lukas */

#ifndef _NETOBJECTS_CLIENT_H
#define _NETOBJECTS_CLIENT_H

#include "netobjects.h"

/**
 * Implements defined IDL operations
 */
class Client_i: public POA_Client,
				public PortableServer::RefCountServantBase
{
public:
	Client_i() { mActive = true; };
	virtual ~Client_i() { };

	/**
	 * Recieves callback how server processed connect
	 */
	void connectCallback(Server_ptr se, CORBA::Long playerID, const char *msg);

	/**
	 * Recieves game info from server
	 */
	void gameInfoCallback(const NETGameInfo &gameInfo);

	/**
	 * Recieves new game state and passes them to NetworkManager
	 *
	 * \param gameState new game state
	 */
	void sendGameState(const NETGameState& gameState);

	/**
	 * Deactivate object
	 */
	// I hope this is atomic(no incorrect data) if accessed(mActive) from multiple threads
	void deactivate() { mActive = false; };

private:
	bool mActive;
};

#endif // _NETOBJECTS_CLIENT_H
