/* MAINTAINER: Lukas */

#ifndef _UNPACKERCONTAINER_H
#define _UNPACKERCONTAINER_H

#include "unpackers.h"

/**
 * Contains all unpackers
 *
 * Unpackers are private attributes in this class. 
 * 
 * For more info see SerializeContainer.
 */
class UnpackerContainer : public SerializeContainer
{
// Every time you create container you register new workers.
// So only UnpackerManager can create container.
friend class UnpackerManager;

private:
	UnpackerContainer() { };
	~UnpackerContainer() { };

	BasicHistoryUnpacker mBasicHistoryUnpacker;
	TankHistoryUnpacker mTankHistoryUnpacker;
	CommandUnpacker mCommandUnpacker;
	CollisionUnpacker mCollisionUnpacker;
	NewTankUnpacker mNewTankUnpacker;
	NewProjectileUnpacker mNewProjectileUnpacker;
	NewBonusBoxUnpacker mNewBonusBoxUnpacker;
	DeletedObjUnpacker mDeletedObjUnpacker;
	PlayerUnpacker mPlayerUnpacker;
	NewPlayerUnpacker mNewPlayerUnpacker;
	DeletedPlayerUnpacker mDeletedPlayerUnpacker;
	StateOfGameUnpacker mStateOfGameUnpacker;
	ConditionStatusUnpacker mConditionStatusUnpacker;

	// HERE YOU PLACE YOUR UNPACKER CLASS AS ATTRIBUTE
};

#endif // _UNPACKERCONTAINER_H
