/* MAINTAINER: Lukas */

#ifndef _UNPACKERMANAGER_H
#define _UNPACKERMANAGER_H

#include "unpackercontainer.h"

/**
 * Runs all unpackers and that packs whole game state
 */
class UnpackerManager : public SerializeManager
{
public:
	UnpackerManager() { };
	virtual ~UnpackerManager() { };

	/**
	 * Create and register all unpackers
	 */
	virtual void init() { mSContainer = new UnpackerContainer(); };

	/**
	 * Unpacks WHOLE given gamestate
	 *
	 * Call all workers that are registred(are in container).
	 *
	 * \param gameState net data that will be unpacked
	 */
	void unpack(const NETGameState & gameState);
};

#endif // _UNPACKERMANAGER_H
