/* MAINTAINER: Martin */

#ifndef _QUEUE_INSERTER_H_
#define _QUEUE_INSERTER_H_

#include "hierarchynodevisitor.h"
#include "counted_ptr.h"
#include "render_queue.h"
#include "GLMatrix.h"
#include "GLVector.h"
#include "GLQuaternion.h"

namespace hna
{
	class Transformation;
};
class Model;

class QueueInserter: protected HierarchyNodeVisitor
{
public:

	QueueInserter( counted_ptr<RenderQueue> renderQueue );

	void insertModel( Model * m, const GLVector3d & position, const GLQuaterniond & orientation );

protected:

	virtual void visitHierarchyNode(class HierarchyNode * node);

private:
	
	inline void getParentTM( GLMatrix4d & tm );
	inline void setParentTM( const GLMatrix4d & tm );
	inline hna::Transformation * getTransformation();

	inline void setFrontFaceOrientation( GLenum orientation );
	inline GLenum getCurrentFrontFaceOrientation() const;
	inline void switchFrontFaceOrientation();
	
	GLMatrix4d mParentTM;
	counted_ptr< RenderQueue > mRenderQueue;
	GLenum mCurrentFrontFaceOrientation;
};

#endif //_QUEUE_INSERTER_H_
