/* MAINTAINER: Martin */
#ifndef _RENDER_VISITOR_H
#define _RENDER_VISITOR_H

#include "SDL_opengl.h"
#include "hierarchy_node.h"
#include "hn_attributeapplyvisitor.h"
#include "gobj_rendervisitor.h"

class RenderVisitor: public HierarchyNodeVisitor
{
public:	
	RenderVisitor();
	virtual void visitHierarchyNode(HierarchyNode * node);

private:

	inline void setFrontFaceOrientation( GLenum orientation );
	inline GLenum getCurrentFrontFaceOrientation() const;
	inline void switchFrontFaceOrientation();
	
	//void applyEffects(HierarchyNode * node);
	//void removeTemporaryEffects(HierarchyNode * node);
	//void removeHierarchyEffects(HierarchyNode * node);

	AttributeApplyVisitor mAAV;
	GLenum mCurrentFrontFaceOrientation;

	//gobj::RenderVisitor mRV;
};

#endif //_RENDER_VISITOR_H

