/* MAINTAINER: Bernard */

#ifndef _SOUND_THEME_H
#define _SOUND_THEME_H

#include <string>

#include "hash_hack.h"
#include "stlextdefs.h"
#include "singleton.h"


class SoundTheme : public Singleton<SoundTheme>
{
	// this makes contructros and destructors
	_singletonDP(SoundTheme)
	
public:

	/**
	 * \brief Load new sound / music theme.
	 *
	 * \param filename allready located file
	 */
	void load(const std::string &filename);
	
	std::string fromTheme(const std::string& original);

	void deleteMe()
	{
		delete this;	
	}

private:
	
	STL_EXT_NS::hash_map<std::string, std::string> mThemeTable;
};

// Used fot the explicit template instantiation in template_instantces_*.cpp file
#ifdef INSTANTIATE_TEMPLATE
	template class Singleton<SoundTheme>;
#endif

#endif
