/* MAINTAINER: Martin */

//#define TESTING
//#define LOAD_TERRAIN

#include "taskrender.h"
#include "application_client.h"
#include "gfx.h"
#include "game_client.h"

#include "world.h"
#include "worldentity.h"

#include "SDL.h"
#include "SDL_opengl.h"

#include "globals_client.h"
#include "application_client.h"
#include "conversions.h"

#include "platform.h" // locateFile()


#include "visual_terrain.h"

// TODO: remove settings #include after removing hacks
#include "settings.h"

TaskRender::TaskRender()
{
}

void TaskRender::init()
{
	Task::init();

	// FPS init
	getAppClient().getGFX().resetFps();	
}

void TaskRender::pushLayer(Layer& layer)
{
	mLayers.push_back(&layer);
}

void TaskRender::clean()
{
	// remove layers from list
	mLayers.clear();
	
	Task::clean();
}

void TaskRender::updateBegin()
{
	getAppClient().getGFX().set3DOpenGL();

	// some Open GL settings
	glClearColor(0.3f, 0.6f, 1, 1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW_MATRIX);
	glLoadIdentity();
}

void TaskRender::updateEnd()
{
	//glFinish();
	getAppClient().getGFX().swap_buffers();
}

void TaskRender::update(int atime)
{
	// update layers
	for (TLayerContainer::iterator it = mLayers.begin(), ite = mLayers.end(); it != ite; ++it){
		(*it)->update();
	}

	// Pre-render-stuffs (i.e. clearing the screen)
	updateBegin();
	
	// render layers
	for (TLayerContainer::iterator it = mLayers.begin(), ite = mLayers.end(); it != ite; ++it){
		(*it)->render();
	}
	
	// post-render-stuffs (i.e. swap buffers)
	updateEnd();
}
