/* MAINTAINER: Bernard */

//#define WANT_TRACE

#include "tasksendyawpitch.h"
#include "player.h"
#include "application_client.h"
#include "tank.h"
#include "log.h"
#include "mousemotion.h"
#include "game_client.h"
#include "networkmanager_client.h"
#include "game_state_copy.h"

TaskSendYawPitch::TaskSendYawPitch()
{
}

TaskSendYawPitch::~TaskSendYawPitch()
{
}



void TaskSendYawPitch::update(int dtime, int atime)
{
	// Send update to the server
	mFromLastSend += dtime;

	if (mFromLastSend >= mSendEveryXms || getAppClient().getGame().getGameStateCopy().getFire())
	{
		if (getAppClient().getGame().getClientPlayer())
		{
			Tank* tank = getAppClient().getGame().getClientPlayer()->getTank();
			if (tank != 0)
			{
				getAppClient().getNetworkManager().sendYawPitch(tank->getYaw(), tank->getPitch());
			}
		}
		mFromLastSend = 0;
	}
}



void TaskSendYawPitch::init()
{
	mFromLastSend = 0;	
	mSendEveryXms = 100;
}

void TaskSendYawPitch::addedWorldObject( WorldEntity * we )
{
	if ( we->getClassType() != cTank )
		return;

	Player * pl = getAppClient().getGame().getClientPlayer();
	if ( !pl )
		return;

	Tank * pl_tnk = pl->getTank();
	if ( !pl_tnk )
		return;

	if ( pl_tnk->getID() == we->getID() )
	{
		pl_tnk->setClientsMain();
	}
}

