/* MAINTAINER: Bernard */

#include "commander.h"
#include "log.h"
#include "globals.h"

using namespace std;

void Commander::addCommand(const std::string &command, int playerID)
{
	if (command.length() == 0) return;

	sCommand cmd(command, playerID);
	mQueueMutex.lock();

	// add command to new position in commands queue
	mCommQueue.push_back(cmd);
	
	mQueueMutex.unlock();
}

void Commander::processAllCommands()
{
	sCommand cmd("", INVALID_PLAYER_ID);

	mQueueMutex.lock();
	// empty queue with commands
	while (!mCommQueue.empty())
	{
		cmd = mCommQueue.front();
		mCommQueue.pop_front();
		mQueueMutex.unlock();

		// process one command
		processCommand(cmd.command, cmd.playerID);

		mQueueMutex.lock();
	}
	
	mQueueMutex.unlock();
}

void Commander::update(int atime)
{
	processAllCommands();
}
