#ifndef _ENTITY_PUBLIC_INFO_H_
#define _ENTITY_PUBLIC_INFO_H_

#include "property.h"
#include "counted_ptr.h"

/**
*	\brief information about entity that it provides out for special purposes
*	This is intended to provide information about an entity that no longer exists. For example, smoke
*	after exploded tank could be there a longer time after the tank disappeared.
*/
class EntityPublicInfo
{
public: _property( GLVector3f, Position );
};

typedef counted_ptr<EntityPublicInfo> EntityPublicInfoPtr;

#endif //_ENTITY_PUBLIC_INFO_H_

