/* MAINTAINER: Lukas */

#ifndef _EVENT_H
#define _EVENT_H

/**
 * This is basic class for all events that manipulate with game data.
 */
class Event
{

public:
	
	Event() { };
	virtual ~Event() { };

	/**
	 * Virtual method that process event.
	 */
	virtual void process() = 0;
	
	/**
	 * Get event's time stamp.
	 *
	 * \return events time stamp
	 */
	int getTimeStamp() { return mTimeStamp; };

	/**
	 * Set event's time stamp.
	 *
	 * \param timeStamp time stam that will be set
	 */
	void setTimeStamp(int timeStamp) { mTimeStamp = timeStamp; };

private:
	
	/**
	 * Event's time stamp
	 */
	int mTimeStamp;

};

#endif // _EVENT_H
