#include "history.h"
#include "globals.h"

#ifndef EXACT_EQUAL_HISTORY_POINTS
#define __HP_TOLER , 0.01
#else
#define __HP_TOLER
#endif

bool HistoryPoint::operator ==(HistoryPoint &hp)
{
	return
		mID == hp.mID &&
		vecEqual( mPosition, hp.mPosition __HP_TOLER) &&
		vecEqual( mSpeed, hp.mSpeed __HP_TOLER) &&
		vecEqual( mAngVelocity, hp.mAngVelocity __HP_TOLER) &&
		vecEqual( mOrientation.getV(), hp.mOrientation.getV() __HP_TOLER) &&
		dblEqual( mOrientation.getW(), hp.mOrientation.getW() __HP_TOLER);
}

bool TanksHistoryPoint::equals(HistoryPoint & hp)
{
	// try to make also TanksHistoryPoint
	TanksHistoryPoint *tp =  dynamic_cast<TanksHistoryPoint*>((&hp));
	if (tp == 0) return false;

	return
		mID == hp.mID &&
		vecEqual( mPosition, hp.mPosition __HP_TOLER) &&
		vecEqual( mSpeed, hp.mSpeed __HP_TOLER) &&
		vecEqual( mAngVelocity, hp.mAngVelocity __HP_TOLER) &&
		vecEqual( mOrientation.getV(), hp.mOrientation.getV() __HP_TOLER) &&
		dblEqual( mOrientation.getW(), hp.mOrientation.getW() __HP_TOLER) &&
		dblEqual( mPitch, tp->mPitch __HP_TOLER) &&
		dblEqual( mYaw, tp->mYaw __HP_TOLER) &&
		mWeapon      == tp->mWeapon &&
		mProjectiles == tp->mProjectiles &&
		mHP          == tp->mHP &&
		mArmour      == tp->mArmour;
}

