/* MAINTAINER: Petko */
#include "player.h"
#include "playernetdata.h"
#include "globals.h"

using namespace std;

void Player::dataInit()
{
	initStats();
	mID      = INVALID_PLAYER_ID;  // invalid ID. Will be set later by Game
	mTank    = 0;
	mNetData = 0;
	mTeam    = -1;
	mDeleteMe= false;
	mDontUpdateClient = false;
	mReady    = false;
	mBigAdmin = false;
	mIsHuman = true;	
}

void Player::initStats()
{
	mKills   = 0;
	mDeaths  = 0;
	mScore   = 0;
	mReady	 = false;
}

Player::~Player()
{
	delete mNetData;
}

Player::Player(Player & copyFrom)
{

		// This uses DEFAULT operator= !!! So... we copy all memory of the player and then 
		// steal the reference to mNetData.
	*this = copyFrom;

	/*
	mID = copyFrom.mID;
	mName = copyFrom.mName;
	mTeam = copyFrom.mTeam;
	mKills = copyFrom.mKills;
	mDeaths = copyFrom.mDeaths;
	mScore = copyFrom.mScore;
	mTank = copyFrom.mTank;
	mPing = copyFrom.mPing;
	mDeleteMe= copyFrom.mDeleteMe;
	mDontUpdateClient = copyFrom.mDontUpdateClient;
	mNetData = copyFrom.mNetData;
	*/

	// steals mNetData
	copyFrom.mNetData = 0;
}

const std::string &Player::getName()
{
	return mName;
}


void Player::setName(const std::string &name)
{
	mName = name;
}
		

int Player::getID() const
{
	return mID;
}
	
void Player::setID(int newID)
{
	mID = newID;

	//TODO: This is just a hack that we need different ID for all players
	mTeam = mID;
}

void Player::setTank(Tank *tank)
{
	mTank = tank;
}

