/* MAINTAINER: Petko */
#include "projectile.h"
#include "globals.h"
#include "application.h"
#include "game.h"
#include "params.h"
#include "tank.h"
#include <limits>

Projectile::Projectile()
{
	mType	= cProjectile;
	mHit	= false;
	mEntity	= -1;
	mParamsID = -1;
}


Projectile::~Projectile()
{

}

void Projectile::initByID( int params_ID )
{
	
	const Params::sProjectileParams & vals = gParams.projectile( params_ID );
	mSpeed= (mOrientation.rotateVector( ZERO_ROTATION_VECTOR )).normalize();

	mDamage		 = vals.getDamage();
	mWeight		 = vals.weight;
	mSpeed		*= vals.speed;
	mPiercing	 = vals.piercing;
	mRadius		 = vals.radius;
	mSubType	 = vals.id;
	
	setModelName( vals.model );
	
	mParamsID  = params_ID;
}

bool Projectile::initSpecific( int shooting_player_id )
{
	mOwner = &(gApp->getGameCommon().getPlayer( shooting_player_id ));
	
	Tank *tank = mOwner->getTank();
	if (tank)
	{
		// Some crazy creator may do the damage really high :)
		int damage = (int)((double)mDamage * tank->getDamageMultiplication());
		if (damage >= 0 && damage < 10000000)
		{
			mDamage = damage;	
		}
	}
	
	return  true;
}

