#include "skybox.h"
#include "application.h"
#include "game.h"
#include "globals.h"


Skybox::Skybox()
{
    Params::sMapParams &map = getApp().getGameCommon().getMapParams();

	mMinx = map.boundaries_min_x;
	mMiny = map.boundaries_min_y;
	mMinz = map.boundaries_min_z;
	mMaxx = map.boundaries_max_x;
	mMaxy = map.boundaries_max_y;
	mMaxz = map.boundaries_max_z;
}

Skybox::~Skybox()
{
}



void Skybox::render()
{
}

bool Skybox::isPointInsideSkyBox(GLVector3d point)
{
	return ( point.x > mMinx && point.x < mMaxx && point.y > mMiny && point.y < mMaxy && 
			 point.z > mMinz && point.z < mMaxz );
}
