/* MAINTAINER: Bernard */

#include "log.h"
#include "globals.h"
#include "tank.h"

const char* BJS_VERSION_STRING = "0.1.3b";

Application *gApp = NULL;
const GLVector3d ZERO_ROTATION_VECTOR( 1, 0 ,0 );


#ifdef _WINDOWS
const char* SUBDIRECTORIES[] = 
{
	"config\\", "data\\", "data\\local\\", "data\\params\\", "data\\music\\", "data\\models\\", "data\\models\\tanks\\", 
	"data\\bitmaps\\", "data\\textures\\", "data\\textures\\tanks\\", "data\\menu\\", "data\\maps\\","data\\scripts\\",
	/* Only for running from VS*/
#ifdef _DEBUG
	"build\\Debug\\",
#else
	"build\\Release\\",
#endif
	/**/
	"", 0
};
#else
const char* SUBDIRECTORIES[] =
{
	"config/", "data/", "data/local/", "data/params/", "data/music/", "data/models/", "data/models/tanks/", 
	"data/bitmaps/", "data/textures/", "data/textures/tanks/", "data/menu/", "data/maps/",  "data/scripts/",
	"", 0
};
#endif

const double DBL_TOLER = 0.0001;

const char NOT_TRANSLATE_CHAR = '#';


Application& getApp()
{
	assertL(gApp);

	return *gApp;
}

const int IOR_TRANSFER_HEADER_SIZE = 8;

const int IOR_TRANSFER_DATA_MAX_SIZE = 4096;


/**
 * \brief ID which is never a valid player ID
 */
const int INVALID_PLAYER_ID = -1;

/**
 * \brief ID which is never a valid entity (landscape or world) ID
 */
const int INVALID_ENTITY_ID = -1;

/**
 * \brief ID which is never a valid weapon ID
 */
const int INVALID_WEAPON_ID = -1;

/**
 * \brief ID which is never a valid projectile ID
 */
const int INVALID_PROJECTILE_ID = -1;


const int INVALID_EXPLOSION_ID = -1;

/**
 * \brief first game state number that will be send over network
 */
const int GS_START_NUMBER = 0;
