/* MAINTAINER: Petko */
#ifndef _HASH_HACK_H
#define _HASH_HACK_H

#ifdef _WINDOWS
#include <hash_map>
#include <hash_set>
#else

#include <ext/hash_map>
#include <ext/hash_set>
#include <string>

// Unfortunatelly STL in gcc doesn't provide hash 
// function for std::string
namespace __gnu_cxx
{
  using std::size_t;
  using std::string;

  // Hashing for strings
  template<>
    struct hash<string>
    {
      size_t
      operator()(const string& __s) const
      { return __stl_hash_string(__s.c_str()); }
    };

  // Hashing for pointers	
  template<class T>
    struct hash<const T*>
    { 
      size_t 
      operator()(const T *__t) const 
      { return (unsigned int)__t; }
    };
}

#endif

					
#endif // _HASH_HACK_H
