/* MAINTAINER: Martin */
#ifndef _GOBJ_BOX_H_
#define _GOBJ_BOX_H_

#include "gobj.h"
#include "gobj_visitor.h"

namespace gobj
{
	class Box: public GeometryObject
	{
	public:
		Box()
			: mExtentX(1.0), mExtentY(1.0), mExtentZ(1.0) 
		{}
		Box(double extentX, double extentY, double extentZ)
			: mExtentX(extentX), mExtentY(extentY), mExtentZ(extentZ) 
		{}

		virtual ~Box(){}

		virtual void accept(Visitor * vis) const
		{ 
			vis->visitBox(this);
		}

		void getExtents(double &extentX, double &extentY, double &extentZ) const
		{
			extentX = mExtentX;
			extentY = mExtentY;
			extentZ = mExtentZ;
		}

		virtual void computeBoundingBox(BoundingBox & bb) const
		{
			getExtents( bb.extents[0], bb.extents[1], bb.extents[2] );
			bb.center[0] = bb.center[1] = 0;
			bb.extents[0] /= 2.0;
			bb.extents[1] /= 2.0;
			bb.center[2] = bb.extents[2] /= 2.0;
		}
				
		//getBoundingBox();
	private:
		double 
			mExtentX, 
			mExtentY, 
			mExtentZ; 
	};
}

#endif //_GOBJ_BOX_H_

