/* MAINTAINER: Martin */
#ifndef _GOBJ_SPHERE_H_
#define _GOBJ_SPHERE_H_

#include "gobj.h"
#include "gobj_visitor.h"

namespace gobj
{
	class Sphere: public GeometryObject
	{
	public:
		Sphere()
			: mRadius(1.0) 
		{}
		Sphere(double radius)
			: mRadius(radius) 
		{}

		virtual ~Sphere(){}

		virtual void accept(Visitor * vis) const
		{ 
			vis->visitSphere(this);
		}

		/** \brief gets sphere radius */
		double getRadius() const
		{
			return mRadius;
		}
		
		virtual void computeBoundingBox(BoundingBox & bb) const
		{
			bb.center[0] = bb.center[1] = bb.center[2] = 0;
			bb.extents[0] = bb.extents[1] = bb.extents[2] = getRadius();
		}
				
		//getBoundingBox();
	private:
		double 
			mRadius;
	};
}

#endif //_GOBJ_SPHERE_H_
