/* MAINTAINER: Martin */
#ifndef _GOBJ_VISITOR_H
#define _GOBJ_VISITOR_H

namespace gobj
{
	/**
	*	\brief geometry objects visitor
	*
	*	Defines interface for visiting geometry objects.
	*	Imagine that one would like to render geometry objects. Then he or she derives a class from 
	*	gobj::Visitor and implements all visit-methods to render those primitives. Rendering will be
	*	performed by visiting geometry objects with this visitor.
	*/
	class Visitor
	{
	protected:
		Visitor(){}
	public:
		virtual ~Visitor(){}

		/** \brief visit-method for Box class */
		virtual void visitBox(const class Box * box) {}

		/** \brief visit-method for Box class */
		virtual void visitSphere(const class Sphere * sphere) {}
		
		/** \brief visit-method for TriMesh class */
		virtual void visitTriMesh(const class TriMesh * trimesh) {}
	};
}

#endif //_GOBJ_VISITOR_H
