#include "groupnodevisitor.h"
#include "hierarchy_node.h"

void GroupNodeVisitor::visitHierarchyNode(class HierarchyNode * node) 
{
	if ( node->isGroupHead() )
	// applicable only to group head node
	{
		visitGroupHead( node );
	}
}

bool GroupNodeVisitor::isNestedGroup( class HierarchyNode * node )
{
	return node->isGroupHead() && node->isGroupMember();
}

void GroupNodeVisitor::visitDirectGroupMembers( class HierarchyNode * node )
{
	HierarchyNode::ChildIterator it( node->getChildrenBegin() ), ite( node->getChildrenEnd() );
	for (; it != ite; ++it )
	{
		if ( (*it)->isGroupMember() )
		{
			visitGroupMember( *it );
		}
	}
}
