/* MAINTAINER: Martin */
#ifndef _ATTRIBUTE_H_
#define _ATTRIBUTE_H_

#include <string>

namespace hna{

	/** 
	*	\brief base class of hierarchy node attributes
	*	
	*	A list of attributes can be associated with hierarchy node of a model.
	*/	
	class Attribute
	{
	protected:
		Attribute(){}
		
		/** \brief copy ctor - used by cloning */
		Attribute(const Attribute & attribute);

	public:
		virtual ~Attribute(){}

		/** \brief accepts attribute visitor */
		virtual void accept(class AttrVisitor *vis){}
		
		/** \brief clones attribute */
		virtual Attribute* clone(void);

		virtual bool isShared(){ return false; };
	};
}


#endif //_ATTRIBUTE_H_

