#include "hna_transform.h"
#include "hna_visitor.h"

using namespace hna;

Transformation::Transformation(void): 
	mNodeTM(GLMatrix4d::identity()),
	mObjectOffsetTM(GLMatrix4d::identity()),
	mMirrorNTM(false), mMirrorOTM(false)
{
}

Transformation::Transformation(const Transformation &t):
	mNodeTM(t.mNodeTM),
	mObjectOffsetTM(t.mObjectOffsetTM),
	mMirrorNTM( t.isMirrorNodeTM() ), mMirrorOTM( t.isMirrorObjectOffsetTM() )
{
}

Transformation::~Transformation()
{
}

Attribute* Transformation::clone(void)
{
	Transformation * new_transformation = new Transformation(*this); // TODO: check NULL
	return new_transformation;
}

void Transformation::accept(AttrVisitor * vis)
{ 
	vis->visitTransformation(this);
}

bool Transformation::isMirrorMatrix( const GLMatrix4d & m )
{
	// return m.det() < 0;
	
	// determinant of the upper 3x3 matrix should be sufficient 
	// (and faster to compute than for entire 4x4 matrix)
	return cofactor_maker(m.m0,m.m5,m.m10, m.m1,m.m6,m.m8, m.m2,m.m4,m.m9) < 0;
}
