/* MAINTAINER: Lukas */

#ifndef _SENDTHREAD_H
#define _SENDTHREAD_H

#include "thread.h"
#include "synchronizedqueue.h"
#include "sendjob.h"

typedef SynchronizedQueue<SendJob *> SendQueue;

/**
 * Thread that sends network jobs
 */
class SendThread : public Thread
{

public:
	
	/**
	 * Create new SendThread
	 *
	 * \param sq synchronized queue with jobs
	 */
	SendThread(SendQueue * sq) { assertL(sq); mSendQueue = sq; };
	~SendThread() { mSendQueue = 0; };

	/**
	 * Process all jobs in queue. If queue is empty wait for new job.
	 */
	int run();

private:

	SendQueue * mSendQueue;
};

#endif // _SENDTHREAD_H

