#ifndef _NOISE_H_
#define _NOISE_H_


#include "function2D.h"
#include "grutils.h"
#include <string>

/**
*	\brief Noise from external image file.
*	\note Only interpolation is implemented, sampling isn't.
*/
class ExternalNoise: public Function2D<double> 
{
public:
	ExternalNoise();
	ExternalNoise(const std::string & imagePath );

	virtual ~ExternalNoise();

	bool load( const std::string & imagePath );

	virtual void getValue(double x, double y, value_type & value ) const;

private:

	double getMaxXAsDouble() const;
	double getMaxYAsDouble() const;
	double getIntensityAsDouble(int x, int y) const;

	struct SDL_Surface * mImage;
	
};

#endif //_NOISE_H_

