/* MAINTAINER: Martin */

#include "refcounter.h"
#include <algorithm>

RefCounter::TTempHeapPointers RefCounter::mTmpHeapPtrs;

RefCounter::~RefCounter()
{
}

RefCounter::RefCounter():
	mRefCount(0)
{
	TTempHeapPointers::iterator it = 
		std::find(mTmpHeapPtrs.begin(), mTmpHeapPtrs.end(), this);
	
	mHeapAllocated = (it != mTmpHeapPtrs.end());

	if (mHeapAllocated)
		mTmpHeapPtrs.erase(it);
}

void * RefCounter::operator new(size_t size)
{
	void * p = ::operator new(size);
	mTmpHeapPtrs.push_front(p);
	return p;
}

void RefCounter::OnZeroRefCount()
{
	if (isHeapAllocated())
		delete this;
}

