/* MAINTAINER: Team */

// def: _set({SYMBOLIC_NAME}, "{name}", "{default_value}")
// use: SETTING_{SYMBOLIC_NAME}

// It is no sense to read this from config file since this
// determine it's name but it may be modified from command line
// even before loading the main setting 
_set(MAIN_CONFIG_FILE,				"main_config_file",				"bjs.conf.xml");


// Configuration from external files

_set(DEVELOPER,						"developer",					"false" );
_set(LOGFILE_SERVER,				"logfile_server",				"bjs.server.log");
_set(TOSTDERR_SERVER,				"stderr_server",				"true");
_set(LOGFILE_CLIENT,				"logfile_client",				"bjs.client.log");
_set(TOSTDERR_CLIENT,				"stderr_client",				"true");
_set(LOGLEVEL,						"log_level",					"2");
_set(TASK_MANAGER_LOOP_MINDELAY,	"engine_mindelay",				"5");
_set(GAME_SPEED_MULTIPLICATOR,		"game_speed_multiplicator",		"1.0");
_set(RESOLUTION,					"resolution",					"640x480");
_set(BPP,							"bpp",							"16");
_set(DOUBLE_BUFFERING,				"double_buffering",				"true");
_set(FULLSCREEN,					"fullscreen",					"true");
_set(CLIENT_CONFIG_FILE,			"client_config_file",			"client.conf.xml");
_set(CLIENT_CONFIG_FILE_TEMPLATE,	"client_config_file_template",	"client.conf.xml.template");
_set(SERVER_CONFIG_FILE,			"server_config_file",			"server.conf.xml");
_set(SERVER_CONFIG_FILE_TEMPLATE,	"server_config_file_template",	"server.conf.xml.template");
_set(TRANSLATION_FILE,				"translation_file",				"en.xml");
_set(TRANSLATIONS_LIST,				"translations_list",			"locals.xml");
_set(CONSOLE_LINES,					"console_lines",				"20");
_set(PARAMS_TANKS_FILE,				"tanks_definitions",			"tanks.xml");
_set(PARAMS_PROJECTILES_FILE,		"projectiles_definitions",		"projectiles.xml");
_set(PARAMS_WEAPONS_FILE,			"weapons_definitions",			"weapons.xml");
_set(PARAMS_BONUS_FILE,				"bonus_definitions",			"bonus.xml");
_set(PARAMS_ENTITIES_FILE,			"land_entities_definitions",    "entities.xml");
_set(PARAMS_EXPLOSIONS_FILE,		"explosions_definitions",       "explosions.xml");

_set(EXPLOSIONS_MIN_DELAY,			"explosions_min_delay",         "20");
_set(EXPLOSIONS_SKIP_ON_SLOW_CPU,	"explosions_skip_on_slow_cpu",  "false");

_set(ENABLE_SOUND,					 "enable_sound",				"true");
_set(ENABLE_MUSIC,					 "enable_music",				"true");
_set(ENABLE_SAMPLES,				 "enable_samples",				"true");
_set(SOUNDTHEME,				 	 "sound_theme",				    "original.xml");
_set(SOUNDTHEMES_LIST,               "sound_theme_list",            "sound_themes.xml");
_set(SAMPLES_VOLUME,				 "samples_volume",				"128");
_set(MUSIC_VOLUME,					 "music_volume",				"128");


_set(LOG_IN_CONSOLE,				 "log_in_console",				"false");

_set(FOVX,						 	 "fovx",					    "60.0");
_set(SHOW_FPS,						 "show_fps",					"true");

_set(MARTIN_TMP_LOD_STEP,				"tmp_LOD_step",				"1");
_set(MARTIN_TMP_FRUSTUM_CULLING,		"tmp_frustum_culling",		"true");
_set(MARTIN_TMP_RENDER_HIERARCHY_TREE,	"tmp_render_hierarchy_tree","false");
_set(MARTIN_TMP_FAR_CAMERA,				"tmp_far_camera",			"false");
_set(SERVER_TMP_BLOCK_SHIFT,			"tmp_server_terrain_blok_shift", "4");
_set(MARTIN_TMP_RENDER_WIREFRAME,		"tmp_render_wireframe",		"false");

_set(TICK_DELAY,					"server_simulation_tick_delay",	"5");
_set(SIMULATION_GRAVITY_CONST,		"gravity_constant",				"10.0");
_set(SIMULATION_ODE_STEPSIZE,		"ode_step_size",				"0.02");
_set(SIMULATION_MAX_STEP_MULTIPLY,	"max_step_multiply",			"3");
_set(SIMULATION_MAX_CPU_PERCENTAGE,	"max_cpu_percentage",			"30");
_set(SIMULATION_BASIC_TANK_WEIGHT,	"basic_tank_weight",			"50000");
//_set(SIMULTAION_BASIC_TANK_TURN,	"basic_tank_turning",			"0.5");
_set(SIMULTAION_TANK_WRECK_LAST,	"tank_wreck_last",				"5");

_set(CONNECT_TRY_SLEEP,             "connect_try_sleep",	        "100");
_set(CONNECT_TRY_CNT,   			"connect_try_cnt",				"10");

_set(GAMEPLAY_CHATTIME,				"chattime",						"10");
_set(GAMEPLAY_MAPCYCLE_FILE,		"mapcycle_file",				"mapcycle.txt");

_set(AI_NAMES_FILE,					"names_file",					"names.txt");

_set(NETWORK_DATA_TRANSMISSIONS,	"network_data_transmissions",	"100");
_set(NETWORK_CORBA_LISTEN_PORT,		"network_corba_listen_port",	"32100");
_set(NETWORK_IOR_TRANFER_PORT,		"network_IOR_transfer_port",	"32101");
_set(NETWORK_CORBA_SHUTDOWN,		"network_corba_shutdown",		"true");
_set(NETWORK_CORBA_TRACE_LEVEL,		"network_corba_trace_level",	"1");
_set(NETWORK_WELCOME_MESSAGE,		"network_welcome_message",		"");

_set(TMP_NETWORK_CONNECT_ADDR,		"tmp_network_connect_ip",		"127.0.0.1");
_set(TMP_NETWORK_CONNECT_PORT,		"tmp_network_connect_port",		"32101");

_set(3DSOUND_ENABLE,                "3dsound_enable",               "true");
_set(3DSOUND_DEVICE,		        "3dsound_device",				"");
_set(3DSOUND_GLOBAL_GAIN,		    "3dsound_global_gain",			"1.0");

_set(GUI_CONFIG_FILE,		        "gui_config_file",				"guiconf.xml");

_set(PLAYER_PREFERED_NAME,          "player_name",                  "Anonymous");
_set(PLAYER_PREFERED_TANK,          "player_tank_id",               "0");

_set(INVERT_MOUSE,                  "invert_mouse",                 "false");
_set(AUTO_INGAME_MENU,              "auto_ingame_menu",             "true");

_set(SERVER_EXECUTABLE,             "server_executable",            "bjs_server");
_set(MAP_LIST_DIRECTORY,            "maps_directory",               "maps");

_set(SINGLE_TIME_WITHOUT_HUMAN,     "single_time_without_human",    "10");  // 10 seconds
_set(MULTI_TIME_WITHOUT_HUMAN,      "multi_time_without_human",     "60");  // 60 seconds
_set(UPDATE_SERVER_LIST_DELAY,      "update_server_list_delay",   "4000");  //  4 seconds



// These are ment to be a command line optins rather then being in config file
_set(SERVER_PASSWORD,			    "server_password",			    "bjs");
_set(SERVER_MAP,                    "server_map",                   "");
_set(GAME_INIT_COMMANDS,            "game_init_commands",           "");
_set(SERVER_SINGLE_PLAYER,          "server_single_player",         "false");
_set(MAX_PLAYERS,                   "max_players",                  "10000");
_set(MAX_TIME_WITHOUT_HUMAN,        "max_time_without_human",       "0");  // 0 means unlimited - miliseconds


// Auto generated
_set(ARGV0,                         "argv0",                        "");
