/* MAINTAINER: Bernard */

/*
*  Class that adds mutex and locking
*
*/

#include "log.h"
#include "mutex.h"
#include "SDL.h"
#include "SDL_thread.h"


/* cretaes mutex */
Mutex::Mutex() 
{
	createMutex();
}

Mutex::Mutex(const Mutex &m) 
{
	createMutex();
}

/* destroys mutex */
Mutex::~Mutex()
{
	assertL(mSDLMutex != 0);
	SDL_DestroyMutex(mSDLMutex);
	mSDLMutex = 0;
}

/* locks mutex */
void Mutex::lock()
{
	assertL(mSDLMutex != 0);
	if(SDL_mutexP(mSDLMutex) == -1)
	{
		LOGE <<  "Couldn't lock mutex" << endl;
		DIE();
	}
}

/* unlocks mutex  */
void Mutex::unlock()
{
	assertL(mSDLMutex != 0);
	if(SDL_mutexV(mSDLMutex) == -1)
	{
		LOGE <<  "Couldn't unlock mutex" << endl;
		DIE();
	}
}

void Mutex::createMutex()
{
	mSDLMutex = SDL_CreateMutex();
	if (mSDLMutex == 0)
	{
		// NOTE that this may corrup program if called before costruction
		// of log mechanism. :)
		LOGE << "Unable to create mutex" << endl;
		DIE();
	}
}
