/* MAINTAINER: Bernard */

#include <climits>
#include "task.h"
#include "log.h"

using namespace std;

Task::Task()
{
	mLastTime = -1;
	mTimeOverflow = 0;
	mTickDelta = 1000;
}

Task::~Task()
{
	
}

void Task::clean()
{

}


void Task::update(int atime)
{
	
	if (mLastTime < 0) 
	{
		update(0, atime);
	} 
	else if (mLastTime > atime)
	{
		LOGW << "Time wrapped around." << endl;
		update(atime + INT_MAX - mLastTime, atime);
	}
	else
	{
		update(atime-mLastTime, atime);
	}	
	
	mLastTime = atime;
}

void Task::tick()
{
	
}

void Task::update(int dtime, int atime)
{
	TVARIABLE2(dtime, atime);
	
	assertL(mTickDelta > 0);
	
	mTimeOverflow += dtime;
	
	while (mTimeOverflow >= mTickDelta)
	{
		tick(); 
		mTimeOverflow -= mTickDelta;
	}
}


void Task::addedWorldObject(WorldEntity* we)
{

}

void Task::deletedWorldObject(WorldEntity* we)
{

}

	
