// MAINTAINER: Martin
#ifndef _WEP_OBTAINER_H_
#define _WEP_OBTAINER_H_

#include "hierarchynodevisitor.h"

#include "GLVector.h"

class WepObtainer: public HierarchyNodeVisitor
{
public:
	WepObtainer();

	bool search( class Model * model );
	
	bool isRotpointValid() { return mRotpointNode != 0; }
	bool isDisplacementValid() { return mWepNode != 0; }
	
	void get( GLVector3d & rotpoint, GLVector3d & displacement );
	
	void getRotPoint(GLVector3d & rotpoint) { rotpoint = mRotpoint; }

private:
	virtual void visitHierarchyNode(class HierarchyNode * node);

	class HierarchyNode 
		* mWepNode, 
		* mRotpointNode;

	GLVector3d 
		mRotpoint, 
		mDisplacement;

	static const GLVector3d DEFAULT_ROTPOINT, DEFAULT_DISPLACEMENT;
};

#endif //_WEP_OBTAINER_H_
