#ifndef _AI_H
#define _AI_H

#include "GLVector.h"

class AIManager;
class Tank;

/**
 * \brief Base class for AI
 */
class AI
{
public:
	AI() { };
	AI(int playerID, AIManager* manager);
	virtual ~AI() {}
	
	/**
	 * \brief Here be the magic. Somehow compute commands for tank.
	 * 
	 * This ensure that controled player has tank and if so calls updateTank.
	 * Else it add command for creating new tank.
	 * It is SURE that mPlayerID is valid when this is called
	 */
	virtual void update();
	
	virtual void updateTank(Tank *tank);
	
	int getControlledPlayerID() { return mPlayerID;  }
	
protected:
	int mPlayerID;
	AIManager *mAIManager;
	
	// For protecting AI from falling off the map
	// 0 ... tank MUST be turning
	// 1 ... tank MUST go straight
	// 2 ... tank may do whatever it wants to
	int getMapLimits();
	
	GLVector3d mShakeHand;  // \brief Misstargeting. 
	
	Tank *mTank;

};


#endif
