#ifndef _AI3_H
#define _AI3_H

#include "GLVector.h"
#include "ai.h"
#include "ai2.h"
#include "luainterface.h"
#include <algorithm>
#include <list>
#include <vector>

extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

#include "log.h"
#include "application_server.h"
#include "game_server.h"
#include "commander.h"
#include "tank.h"
#include "world.h"
#include "aimanager.h"
#include "gameplaysettings.h"
#include "terrain.h"
#include "landscape.h"

class World;
class Landscape;
class Terrain;
class AIManager;
class Tank;
class AI;
class AI2;


class AI3 : public AI2
{
public:
	AI3(int playerID, AIManager* manager, int newtype = 3);
	virtual ~AI3();

	// void setType( int newtype ) { type  = type; return; }
	// int getType() { return type; }
	
	virtual void updateTank(Tank *tank);
	
	Tank * getmTank() { return mTank; };
	GLVector3d * getmPathEnd() { return &mPathEnd; };
	std::list< PathNode * > * getmPath() { return &mPath; };
	bool getmMoving() { return mMoving; };
	GLVector3d * getmTarget() { return &mTarget; };
	GLVector3d * getmShakeHand() { return &mShakeHand; };
	AIManager * getmAIManager() { return mAIManager; };
	int getmPlayerID() { return mPlayerID; };

	void printPath();

protected:

	void moveByPath();
	lua_State * mLuaState;
	int type;

};

#endif
