/* MAINTAINER: Bernard */

#ifndef _CONSOLE_TEXT_H
#define _CONSOLE_TEXT_H

#include "thread.h"

/**
 * \brief Console for terminal.
 *
 * Read from input and send commands to commander. Isn't equal to 
 * client's pop-up console. The console must run in separate thread because
 * reading of input is blocking operationa and we don't want to block the engine ;)
 * NOTE that this class doesn't support stop();
 */
class ConsoleText : public Thread
{
public:
	ConsoleText();
	virtual ~ConsoleText();

	/**
	 * \brief The runing thread of console.
	 */
	virtual int run();

	virtual void stop();
};

#endif
