/* MAINTAINER: Lukas */

// #define WANT_TRACE

#include "log.h"
#include "events_server.h"
#include "application_server.h"
#include "inputconstants.h"
#include "playernetdata_server.h"
#include "tank.h"
#include "game_server.h"
#include "networkmanager_server.h"
#include "commander.h"
#include "mapcycle.h"

#include "playernetdata_server.h"

void EvCommand::process()
{
	getAppServer().getCommander().addCommand(mCommand, mPlayerID);
}

void EvInputButton::process()
{
	//TODO: toto je samozrejme hack...
	//mPlayerID = 2;

	LOGT << "Processing input:  player=" << mPlayerID 
	     << " button=" << mButton << " value=" << mValue << endl;
	
	if (getAppServer().getGame().isPlayerIDValid(mPlayerID))
	{
		
		Tank *tank = getAppServer().getGame().getPlayer(mPlayerID).getTank();
		if (tank)
		{
			tank->setYawPitch(mYaw, mPitch);

			Tank::TankCommands &cmd = tank->getCmds();
			switch (mButton)
			{
				case BUTTON_LEFT:     cmd.left     = mValue; break;
				case BUTTON_RIGHT:    cmd.right    = mValue; break;
				case BUTTON_FORWARD:  cmd.forward  = mValue; break;
				case BUTTON_BACKWARD: cmd.backward = mValue; break;
				case BUTTON_FIRE:     cmd.fire     = mValue; break;
			}			
		}
	}
}

void EvYawPitch::process()
{
	//TODO: toto je samozrejme hack...
	//mPlayerID = 2;

	LOGT << mYaw << " " << mPitch << endl;

	if (getAppServer().getGame().isPlayerIDValid(mPlayerID))
	{
		Tank *tank = getAppServer().getGame().getPlayer(mPlayerID).getTank();
		if (tank)
		{
			tank->setYawPitch(mYaw, mPitch);
		}
	}
}

void EvPlayerConnected::process()
{
	Player pl(new PlayerNetDataServer(mClient));
	pl.setName(mPlayerName);

	// it's ok to pass pl because newPlayer() makes copy
	int id = getAppServer().getGame().newPlayer(pl);
	
	if(id != INVALID_PLAYER_ID)
	{
		assertL(getAppServer().getGame().getPlayer(id).canUpdateClient());

		dynamic_cast<PlayerNetDataServer &>(	
			getAppServer().getGame().getPlayer(id).netData()).setHandler(new Server_i(id));

		getAppServer().getNetworkManager().addPlayerCallback(mClient, id);
	}
	else
		// TODO LUKAS pridat dalsi hlasky proc se nejde pripojit
		getAppServer().getNetworkManager().addPlayerCallback(mClient, id, "Server is full.");
}

void EvGameInfoRequest::process()
{
	GameInfo gi;

	gi.mapName = getAppServer().getMapCycle().getActualMapFile();

	getAppServer().getNetworkManager().gameInfoCallback(gi, mPlayerID);

}

void EvPlayerDisconnected::process()
{
	if(getAppServer().getGame().isPlayerIDValid(mPlayerID))
		getAppServer().getGame().preparePlayerDeletion( mPlayerID );
}
