/* MAINTAINER: Lukas */

#include "bonusbox.h"
#include "application_server.h"
#include "history.h"
#include "world.h"
#include "tank.h"
#include "log.h"
#include "game_server.h"
#include "netobjects.h"

void BonusBox::packCreationData(NETGameState & data)
{
	// actual points at the end of newTanks
	int actual = data.newObj.newBonusBoxes.length();

	// add one tank creation data - actual points at the end
	data.newObj.newBonusBoxes.length(actual + 1);

	NETNewBonusBox & nbbData = data.newObj.newBonusBoxes[actual];

	// DATA COPY
	
	// ID
	nbbData.id = getID();

	// Type
	nbbData.type = getSubType();

	// orientation
	nbbData.orientation.x = (float)getPresentPoint()->mOrientation.getV().x;
	nbbData.orientation.y = (float)getPresentPoint()->mOrientation.getV().y;
	nbbData.orientation.z = (float)getPresentPoint()->mOrientation.getV().z;
	nbbData.orientation.w = (float)getPresentPoint()->mOrientation.getW();

	// position
	nbbData.position.x = (float)getPresentPoint()->mPosition.x;
	nbbData.position.y = (float)getPresentPoint()->mPosition.y;
	nbbData.position.z = (float)getPresentPoint()->mPosition.z;
}

void BonusBox::render()
{
	DIE("Access to render() on server");
}


void BonusBox::handleCollisionWEntityServer( int id, const GLVector3d & coll_pos, const GLVector3d & coll_normal )
{
	WorldEntity *we = getAppServer().getGame().getWorld().getWorldEntity(id);
	if (we->getClassType() == cTank)
	{
		Tank * tnk = dynamic_cast< Tank* >( we );
		if ( tnk->lives() )
			picked( *tnk );
	}
}
