/* MAINTAINER: Lukas */

#include "history.h"
#include "netobjects.h"

void HistoryPoint::transferToNET(NETGameState & data)
{
	// actual points at the end of basicTypes
	int actual = data.objects.basicTypes.length();

	// add one basic type - actual points at the end
	data.objects.basicTypes.length(actual + 1);

	NETWEBasicType & btData = data.objects.basicTypes[actual];

	// DATA COPY
	transferToNETDirect(btData);
}

void HistoryPoint::transferToNETDirect(NETWEBasicType & data)
{
	// ID
	data.ID = mID;

	// time stamp
	data.timeStamp = mTimeStamp;

	// orientation
	data.orientation.x = static_cast<float>(mOrientation.getV().x);
	data.orientation.y = static_cast<float>(mOrientation.getV().y);
	data.orientation.z = static_cast<float>(mOrientation.getV().z);
	data.orientation.w = static_cast<float>(mOrientation.getW());

	// position
	data.position.x = static_cast<float>(mPosition.x);
	data.position.y = static_cast<float>(mPosition.y);
	data.position.z = static_cast<float>(mPosition.z);

	// speed
	data.speed.x = static_cast<float>(mSpeed.x);
	data.speed.y = static_cast<float>(mSpeed.y);
	data.speed.z = static_cast<float>(mSpeed.z);

	// angVelocity
	data.angVelocity.x = static_cast<float>(mAngVelocity.x);
	data.angVelocity.y = static_cast<float>(mAngVelocity.y);
	data.angVelocity.z = static_cast<float>(mAngVelocity.z);
}
