/* MAINTAINER: Lukas */

#ifndef _BASICOBJECTCONFRONTOR_H
#define _BASICOBJECTCONFRONTOR_H

#include "confrontor.h"
#include "globals.h"

/**
 * Basic confrontor
 *
 * Checks if entity has been modified
 */
class BasicConfrontor : public Confrontor
{
public:
	BasicConfrontor() { };
	virtual ~BasicConfrontor() { };

	/**
	 * Determines whether is object same as was send last tim
	 *
	 * \param we tested world entity
	 *
	 * \return true if world entity is relevant false otherwise
	 */
	virtual bool isObjectRelevant(WorldEntity * we);
	
	/**
	 * Determines whether is collision to old to send
	 *
	 * \param coll tested collision
	 *
	 * \return true if world entity is relevant false otherwise
	 */
	virtual bool isCollisionRelevant(const Collision & coll);

	virtual void init(int playerID) { mPlayerID = playerID; };

	virtual void clean() { mPlayerID = INVALID_PLAYER_ID; };

private:
	int mPlayerID;
};

#endif // _BASICOBJECTCONFRONTOR_H
