/* MAINTAINER: Lukas */

#include "thread.h"
#include "log.h"

#ifndef _ORBTHREAD_H
#define _ORBTHREAD_H

/**
 * This is thread that runs Orb
 */
class OrbThread : public Thread
{
public:

	/**
	 * Run Orb
	 */
	virtual int run();

	/**
	 * Set listen CORBA port
	 *
	 * \param port listen CORBA port
	 */
	void setCorbaPort(int port)
	{
		assertL(port > 0);
		mCorbaPort = port;
	}

	/**
	 * Get listen CORBA port
	 *
	 * \return listen CORBA port
	 */
	int getCorbaPort()
	{
		return mCorbaPort;
	}

private:
	int mCorbaPort;

};

#endif // _ORBTHREAD_H
