/* MAINTAINER: Lukas */

#ifndef _PACKERCONTAINER_H
#define _PACKERCONTAINER_H

#include "packers.h"

/**
 * Contains all packers
 *
 * Packers are private attributes in this class. 
 * 
 * For more info see SerializeContainer.
 */
class PackerContainer : public SerializeContainer
{
// Every time you create container you register new workers.
// So only PackerManager can create container.
friend class PackerManager;

private:
	PackerContainer() { };
	~PackerContainer() { };

	HistoryPacker mHistoryPacker;
	CommandPacker mCommandPacker;
	CollisionsPacker mCollisionsPacker;
	NewObjectsPacker mNewObjectsPacker;
	DeletedObjectsPacker mDeletedObjectsPacker;
	PlayersPacker mPlayersPacker;
	NewPlayersPacker mNewPlayersPacker;
	DeletedPlayersPacker mDeletedPlayersPacker;
	GameStateNumberPacker mGameStateNumberPacker;
	StateOfGamePacker mStateOfGamePacker;
	ConditionStatusPacker mConditionStatusPacker;

	// HERE YOU PLACE YOUR PACKER CLASS AS ATTRIBUTE
};

#endif // _PACKERCONTAINER_H
