/* MAINTAINER: Lukas */

#ifndef _PACKERWORKER_H
#define _PACKERWORKER_H

#include "serializemanager.h"
#include "log.h"

class PackerManager;

/**
 * This is basic class for all packers
 */
class PackerWorker : public SerializeWorker
{
public:
	/**
	 * Register packer at PackerManager
	 */
	PackerWorker();

	/**
	 * Unregister Packer at PackerManager
	 */
	virtual ~PackerWorker();

	/**
	 * Packs data to the given game state
	 *
	 * What is packed depends on concrete packer.
	 *
	 * \param gameState net data where will be packed
	 */
	virtual void pack(NETGameState & gameState) = 0;

protected:
	PackerManager & getPackerManager() { return mPackerManager; };

private:
	
	static const int defaultPriority = 200;

	PackerManager & mPackerManager;
};

#endif // _PACKERWORKER_H
