/* MAINTAINER: Lukas */

#include "playernetdata_server.h"
#include "globals.h"
#include "game.h"

PlayerNetDataServer::PlayerNetDataServer(Client_var client)
{	
	assertL(! CORBA::is_nil(client));

	mClient = client;
	mGSNumber = GS_START_NUMBER;
	mServer = 0;
	mStateOfGame = WaitForPlayers;

	// mSendQueue and pass it to mSendThread
	mSendQueue = new SendQueue();
	mSendThread = new SendThread(mSendQueue);

	// start send thread
	mSendThread->start();
}

PlayerNetDataServer::~PlayerNetDataServer()
{	
	 assertL(!mServer);
	 assertL(mSendQueue);
	 assertL(mSendThread);

	 // stop SendThread
	 mSendThread->setStop();

	 // process setStop() if no job present
	 mSendQueue->push(new NopJob());

	 // TODO LUKAS hod tento thread(+ queue) nejakemu thread destroierovi
	 // ktery se stara o neukoncene thready a vola na ne wait az skonci
	 // + smaze jejich strukturu
	 
}

void KnownWorldEntities::add(int id, HistoryPoint * netPoint)
{
	assertL(netPoint);

	KnownWE * ko = new KnownWE(id, netPoint);

	mKnownObjects.push_back(ko);
}

void KnownPlayers::add(int id, std::string name)
{
	KnownPlayer * ko = new KnownPlayer(id, name);

	mKnownObjects.push_back(ko);
}