/* MAINTAINER: Lukas */

#include "tasksendchanges.h"
#include "application_server.h"
#include "networkmanager_server.h"
#include "settings.h"

void TaskSendChanges::update(int dtime, int atime)
{
	getAppServer().getNetworkManager().collectDataForClients();
	
	mDTimeSum += dtime;

	if(mDTimeSum >= mSendTime)
	{
		if(getAppServer().getNetworkManager().numberOfClients() > 0)
			getAppServer().getNetworkManager().sendDataToClients();

		mDTimeSum = 0;
	}
}

void TaskSendChanges::init()
{
	mDTimeSum = 0;

	// number of network data transmissions in 1s
	mSendsCount = g_settings.getInt(SETTING_NETWORK_DATA_TRANSMISSIONS);

	mSendTime = 1000/mSendsCount; // number of ms between network data transmissions
}
