/* MAINTAINER: Bernard */
#include "taskserverkiller.h"
#include "application_server.h"
#include "game_server.h"
#include "settings.h"
#include "commander.h"

TaskServerKiller::TaskServerKiller()
{
	mTimeWithoutHuman = 0;	
}

void TaskServerKiller::init()
{
	mTimeWithoutHuman = 0;	
}
		
	
void TaskServerKiller::update(int dtime, int atime)
{
	if (getAppServer().getGame().getHumanPlayerCount() > 0)
	{
		// We have human players
		mTimeWithoutHuman = 0;
	}
	else
	{
		// we don'h have human players
		mTimeWithoutHuman += dtime;
		// note that timelimit is on seconds
		int timelimit = g_settings.getInt(SETTING_MAX_TIME_WITHOUT_HUMAN);
		
		// Are we without human for too long?
		if (timelimit != 0 && mTimeWithoutHuman > timelimit*1000)
		{
			LOGW << "The server was running without players for too long. Automatic shuitdown." << endl;
			getAppServer().getCommander().addCommand("/quit");
		}
	}
}
