/* MAINTAINER: Bernard */
#ifndef _TASK_SERVER_KILLER_H
#define _TASK_SERVER_KILLER_H

#include "task.h"

/**
 * \brief The task is checking number of players and if the server is abandoned it gives up.
 * 
 * The task is here to avoid situations when by some accident server continue running even if it has
 * no players for too long. You may of course create server wunning forever without players
 * but this shold help situations where for example player create a singleplayer game and connectig
 * to server fails somehow. The problem is that server is running, has no players and nobody know
 * admin password :) The server of course blocks port for broadcast and no other server may be
 * started on same machine... We don't expect all our players to be able to work with taskmanager 
 * (or kill -9) and kill the server themself :)
 */
class TaskServerKiller : public Task
{
public:	

	TaskServerKiller();

	/**
	 * \brief Just some basi inicialization of mTimeWithoutHuman
	 */
	virtual void init();
		
	/**
	 * \brief Accumulationg time withou human player.
	 */
	virtual void update(int dtime, int atime);

	
protected:
	int mTimeWithoutHuman; ///< \brief Time in miliseconds since last human player seen.
};

#endif

